diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeBlocks.java b/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeBlocks.java
new file mode 100644
index 000000000..3382db5d9
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeBlocks.java
@@ -0,0 +1,591 @@
+package net.minecraft.core.player.inventory;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.IPainted;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
+
+import java.util.List;
+
+public final class CreativeBlocks {
+
+	private static final DyeColor[] RAINBOW_ORDER = {
+		DyeColor.RED,
+		DyeColor.ORANGE,
+		DyeColor.YELLOW,
+		DyeColor.LIME,
+		DyeColor.GREEN,
+		DyeColor.CYAN,
+		DyeColor.LIGHT_BLUE,
+		DyeColor.BLUE,
+		DyeColor.PURPLE,
+		DyeColor.MAGENTA,
+		DyeColor.PINK,
+		DyeColor.BROWN,
+		DyeColor.WHITE,
+		DyeColor.SILVER,
+		DyeColor.GRAY,
+		DyeColor.BLACK
+	};
+
+	public static void populate(List<ItemStack> list) {
+
+		addStoneTypes(list);
+
+		addWoodTypes(list);
+
+		//WOOL
+		addPainted(list, Blocks.WOOL, painted(Blocks.WOOL));
+
+		addNaturalTypes(list);
+
+		addOrganicTypes(list);
+
+
+		//WORKSTATIONS
+		add(list, Blocks.WORKBENCH);
+
+		add(list, Blocks.FURNACE_STONE_IDLE);
+		add(list, Blocks.FURNACE_BLAST_IDLE);
+
+		add(list, Blocks.TROMMEL_IDLE);
+
+		add(list, Blocks.CHEST_PLANKS_OAK);
+		addPainted(list, Blocks.CHEST_PLANKS_OAK_PAINTED, painted(Blocks.CHEST_PLANKS_OAK_PAINTED));
+
+		add(list, Blocks.BOOKSHELF_PLANKS_OAK);
+		add(list, Blocks.LADDER_OAK);
+		add(list, Blocks.TORCH_COAL);
+
+		add(list, Blocks.GLASS);
+		add(list, Blocks.TRAPDOOR_GLASS);
+
+		add(list, Blocks.GLASS_TINTED);
+
+		add(list, Blocks.GLASS_STEEL);
+
+
+		addRedstoneTypes(list);
+
+		addOreTypes(list);
+
+		addStorageTypes(list);
+
+		add(list, Blocks.PAPER_WALL);
+		add(list, Blocks.FENCE_PAPER_WALL);
+
+		add(list, Blocks.FENCE_CHAINLINK);
+		add(list, Blocks.FENCE_STEEL);
+
+	}
+
+	public static void addStoneTypes(List<ItemStack> list) {
+		// STONE
+		add(list, Blocks.STONE);
+		add(list, Blocks.MOSS_STONE);
+
+		add(list, Blocks.COBBLE_STONE);
+		add(list, Blocks.STAIRS_COBBLE_STONE);
+		add(list, Blocks.SLAB_COBBLE_STONE);
+		add(list, Blocks.COBBLE_STONE_MOSSY);
+
+		add(list, Blocks.BRICK_STONE);
+		add(list, Blocks.STAIRS_BRICK_STONE);
+		add(list, Blocks.SLAB_BRICK_STONE);
+
+		add(list, Blocks.STONE_POLISHED);
+		add(list, Blocks.SLAB_STONE_POLISHED);
+		add(list, Blocks.STONE_CARVED);
+
+		add(list, Blocks.BRICK_STONE_POLISHED);
+		add(list, Blocks.STAIRS_BRICK_STONE_POLISHED);
+		add(list, Blocks.SLAB_BRICK_STONE_POLISHED);
+		add(list, Blocks.BRICK_STONE_POLISHED_MOSSY);
+
+
+		//BASALT
+		add(list, Blocks.BASALT);
+		add(list, Blocks.MOSS_BASALT);
+
+		add(list, Blocks.COBBLE_BASALT);
+		add(list, Blocks.STAIRS_COBBLE_BASALT);
+		add(list, Blocks.SLAB_COBBLE_BASALT);
+		add(list, Blocks.COBBLE_BASALT_MOSSY);
+
+		add(list, Blocks.BRICK_BASALT);
+		add(list, Blocks.STAIRS_BRICK_BASALT);
+		add(list, Blocks.SLAB_BRICK_BASALT);
+
+		add(list, Blocks.BASALT_POLISHED);
+		add(list, Blocks.SLAB_BASALT_POLISHED);
+		add(list, Blocks.BASALT_CARVED);
+
+
+		//LIMESTONE
+		add(list, Blocks.LIMESTONE);
+		add(list, Blocks.MOSS_LIMESTONE);
+
+		add(list, Blocks.COBBLE_LIMESTONE);
+		add(list, Blocks.STAIRS_COBBLE_LIMESTONE);
+		add(list, Blocks.SLAB_COBBLE_LIMESTONE);
+		add(list, Blocks.COBBLE_LIMESTONE_MOSSY);
+
+		add(list, Blocks.BRICK_LIMESTONE);
+		add(list, Blocks.STAIRS_BRICK_LIMESTONE);
+		add(list, Blocks.SLAB_BRICK_LIMESTONE);
+
+		add(list, Blocks.LIMESTONE_POLISHED);
+		add(list, Blocks.SLAB_LIMESTONE_POLISHED);
+		add(list, Blocks.LIMESTONE_CARVED);
+
+
+		//GRANITE
+		add(list, Blocks.GRANITE);
+		add(list, Blocks.MOSS_GRANITE);
+
+		add(list, Blocks.COBBLE_GRANITE);
+		add(list, Blocks.STAIRS_COBBLE_GRANITE);
+		add(list, Blocks.SLAB_COBBLE_GRANITE);
+		add(list, Blocks.COBBLE_GRANITE_MOSSY);
+
+		add(list, Blocks.BRICK_GRANITE);
+		add(list, Blocks.STAIRS_BRICK_GRANITE);
+		add(list, Blocks.SLAB_BRICK_GRANITE);
+
+		add(list, Blocks.GRANITE_POLISHED);
+		add(list, Blocks.SLAB_GRANITE_POLISHED);
+		add(list, Blocks.GRANITE_CARVED);
+
+
+		//PERMAFROST
+		add(list, Blocks.PERMAFROST);
+
+		add(list, Blocks.COBBLE_PERMAFROST);
+		add(list, Blocks.STAIRS_COBBLE_PERMAFROST);
+		add(list, Blocks.SLAB_COBBLE_PERMAFROST);
+
+		add(list, Blocks.BRICK_PERMAFROST);
+		add(list, Blocks.STAIRS_BRICK_PERMAFROST);
+		add(list, Blocks.SLAB_BRICK_PERMAFROST);
+
+		add(list, Blocks.PERMAFROST_POLISHED);
+		add(list, Blocks.SLAB_PERMAFROST_POLISHED);
+		add(list, Blocks.PERMAFROST_CARVED);
+
+
+		//NETHERRACK
+		add(list, Blocks.NETHERRACK);
+
+		add(list, Blocks.COBBLE_NETHERRACK);
+		add(list, Blocks.STAIRS_COBBLE_NETHERRACK);
+		add(list, Blocks.SLAB_COBBLE_NETHERRACK);
+		add(list, Blocks.COBBLE_NETHERRACK_CRYSTALLINE);
+
+		add(list, Blocks.BRICK_NETHERRACK);
+		add(list, Blocks.STAIRS_BRICK_NETHERRACK);
+		add(list, Blocks.SLAB_BRICK_NETHERRACK);
+
+		add(list, Blocks.NETHERRACK_POLISHED);
+		add(list, Blocks.SLAB_NETHERRACK_POLISHED);
+		add(list, Blocks.NETHERRACK_CARVED);
+
+
+		//GLOOMSTONE
+		add(list, Blocks.GLOOMSTONE);
+
+		add(list, Blocks.COBBLE_GLOOMSTONE);
+		add(list, Blocks.STAIRS_COBBLE_GLOOMSTONE);
+		add(list, Blocks.SLAB_COBBLE_GLOOMSTONE);
+
+		add(list, Blocks.BRICK_GLOOMSTONE);
+		add(list, Blocks.STAIRS_BRICK_GLOOMSTONE);
+		add(list, Blocks.SLAB_BRICK_GLOOMSTONE);
+
+		add(list, Blocks.GLOOMSTONE_POLISHED);
+		add(list, Blocks.SLAB_GLOOMSTONE_POLISHED);
+		add(list, Blocks.GLOOMSTONE_CARVED);
+
+
+		//MARBLE
+		add(list, Blocks.MARBLE);
+
+		add(list, Blocks.BRICK_MARBLE);
+		add(list, Blocks.STAIRS_BRICK_MARBLE);
+		add(list, Blocks.SLAB_BRICK_MARBLE);
+
+		add(list, Blocks.PILLAR_MARBLE);
+		add(list, Blocks.CAPSTONE_MARBLE);
+		add(list, Blocks.SLAB_CAPSTONE_MARBLE);
+
+
+		//SLATE
+		add(list, Blocks.SLATE);
+		add(list, Blocks.LAYER_SLATE);
+
+		add(list, Blocks.BRICK_SLATE);
+		add(list, Blocks.STAIRS_BRICK_SLATE);
+		add(list, Blocks.SLAB_BRICK_SLATE);
+
+		add(list, Blocks.SLATE_POLISHED);
+		add(list, Blocks.SLAB_SLATE_POLISHED);
+		add(list, Blocks.SLATE_CARVED);
+	}
+
+	public static void addWoodTypes(List<ItemStack> list) {
+		add(list, Blocks.PLANKS_OAK);
+		addPainted(list, Blocks.PLANKS_OAK_PAINTED, painted(Blocks.PLANKS_OAK_PAINTED));
+
+		add(list, Blocks.STAIRS_PLANKS_OAK);
+		addPainted(list, Blocks.STAIRS_PLANKS_PAINTED, painted(Blocks.STAIRS_PLANKS_PAINTED));
+		add(list, Blocks.SLAB_PLANKS_OAK);
+		addPainted(list, Blocks.SLAB_PLANKS_PAINTED, painted(Blocks.SLAB_PLANKS_PAINTED));
+
+		add(list, Blocks.FENCE_PLANKS_OAK);
+		addPainted(list, Blocks.FENCE_PLANKS_OAK_PAINTED, painted(Blocks.FENCE_PLANKS_OAK_PAINTED));
+
+		add(list, Blocks.FENCE_GATE_PLANKS_OAK);
+		addPainted(list, Blocks.FENCE_GATE_PLANKS_OAK_PAINTED, painted(Blocks.FENCE_GATE_PLANKS_OAK_PAINTED));
+
+		add(list, Blocks.TRAPDOOR_PLANKS_OAK);
+		addPainted(list, Blocks.TRAPDOOR_PLANKS_PAINTED, painted(Blocks.TRAPDOOR_PLANKS_PAINTED));
+	}
+
+	public static void addOrganicTypes(List<ItemStack> list) {
+		//LOGS
+		add(list, Blocks.LOG_OAK);
+		add(list, Blocks.LOG_OAK_MOSSY);
+		add(list, Blocks.LOG_PINE);
+		add(list, Blocks.LOG_BIRCH);
+		add(list, Blocks.LOG_CHERRY);
+		add(list, Blocks.LOG_EUCALYPTUS);
+		add(list, Blocks.LOG_THORN);
+		add(list, Blocks.LOG_PALM);
+		add(list, Blocks.LOG_SCORCHED);
+
+
+		//LEAVES
+		add(list, Blocks.LEAVES_OAK);
+		add(list, Blocks.LAYER_LEAVES_OAK);
+		add(list, Blocks.LEAVES_OAK_RETRO);
+		add(list, Blocks.LEAVES_PINE);
+		add(list, Blocks.LEAVES_BIRCH);
+		add(list, Blocks.LEAVES_CHERRY);
+		add(list, Blocks.LEAVES_CHERRY_FLOWERING);
+		add(list, Blocks.LEAVES_EUCALYPTUS);
+		add(list, Blocks.LEAVES_THORN);
+		add(list, Blocks.LEAVES_PALM);
+		add(list, Blocks.LEAVES_SHRUB);
+		add(list, Blocks.LEAVES_CACAO);
+
+
+		//SAPLINGS
+		add(list, Blocks.SAPLING_OAK);
+		add(list, Blocks.SAPLING_OAK_RETRO);
+		add(list, Blocks.SAPLING_PINE);
+		add(list, Blocks.SAPLING_BIRCH);
+		add(list, Blocks.SAPLING_CHERRY);
+		add(list, Blocks.SAPLING_EUCALYPTUS);
+		add(list, Blocks.SAPLING_THORN);
+		add(list, Blocks.SAPLING_PALM);
+		add(list, Blocks.SAPLING_SHRUB);
+		add(list, Blocks.SAPLING_CACAO);
+
+
+		//FLOWERS
+		list.add(new ItemStack(Blocks.FLOWER_YELLOW, 1, 0));
+//		list.add(new ItemStack(Blocks.FLOWER_YELLOW, 1, 32);
+//		list.add(new ItemStack(Blocks.FLOWER_YELLOW, 1, 64);
+//		list.add(new ItemStack(Blocks.FLOWER_YELLOW, 1, 96);
+
+		list.add(new ItemStack(Blocks.FLOWER_RED, 1, 0));
+//		list.add(new ItemStack(Blocks.FLOWER_RED, 1, 32);
+//		list.add(new ItemStack(Blocks.FLOWER_RED, 1, 64);
+//		list.add(new ItemStack(Blocks.FLOWER_RED, 1, 96);
+
+		list.add(new ItemStack(Blocks.FLOWER_PINK, 1, 0));
+//		list.add(new ItemStack(Blocks.FLOWER_PINK, 1, 32);
+//		list.add(new ItemStack(Blocks.FLOWER_PINK, 1, 64);
+//		list.add(new ItemStack(Blocks.FLOWER_PINK, 1, 96);
+
+		list.add(new ItemStack(Blocks.FLOWER_PURPLE, 1, 0));
+//		list.add(new ItemStack(Blocks.FLOWER_PURPLE, 1, 32);
+//		list.add(new ItemStack(Blocks.FLOWER_PURPLE, 1, 64);
+//		list.add(new ItemStack(Blocks.FLOWER_PURPLE, 1, 96);
+
+		list.add(new ItemStack(Blocks.FLOWER_LIGHT_BLUE, 1, 0));
+//		list.add(new ItemStack(Blocks.FLOWER_LIGHT_BLUE, 1, 32);
+//		list.add(new ItemStack(Blocks.FLOWER_LIGHT_BLUE, 1, 64);
+//		list.add(new ItemStack(Blocks.FLOWER_LIGHT_BLUE, 1, 96);
+
+		list.add(new ItemStack(Blocks.FLOWER_ORANGE, 1, 0));
+//		list.add(new ItemStack(Blocks.FLOWER_ORANGE, 1, 32);
+//		list.add(new ItemStack(Blocks.FLOWER_ORANGE, 1, 64);
+//		list.add(new ItemStack(Blocks.FLOWER_ORANGE, 1, 96);
+
+		add(list, Blocks.MUSHROOM_BROWN);
+		add(list, Blocks.MUSHROOM_RED);
+
+		//FOLIAGE
+		add(list, Blocks.TALLGRASS);
+		add(list, Blocks.TALLGRASS_FERN);
+		add(list, Blocks.DEADBUSH);
+		add(list, Blocks.SPINIFEX);
+		add(list, Blocks.ALGAE);
+		add(list, Blocks.CACTUS);
+
+		add(list, Blocks.PUMPKIN);
+		add(list, Blocks.PUMPKIN_CARVED_IDLE);
+		add(list, Blocks.PUMPKIN_CARVED_ACTIVE);
+
+		add(list, Blocks.BLOCK_SUGARCANE);
+		add(list, Blocks.BLOCK_SUGARCANE_BAKED);
+
+		add(list, Blocks.SPONGE_DRY);
+		add(list, Blocks.SPONGE_WET);
+
+		add(list, Blocks.PUMICE_DRY);
+		add(list, Blocks.PUMICE_WET);
+
+		add(list, Blocks.COBWEB);
+
+		add(list, Blocks.BONE_PILE);
+		add(list, Blocks.SOUL_CATCHER);
+		add(list, Blocks.BOULDER_MAGMATIC);
+		add(list, Blocks.BOULDER_SULFURIC);
+	}
+
+	public static void addNaturalTypes(List<ItemStack> list) {
+		add(list, Blocks.GRASS);
+		add(list, Blocks.GRASS_SCORCHED);
+		add(list, Blocks.GRASS_RETRO);
+
+		add(list, Blocks.DIRT);
+		add(list, Blocks.PATH_DIRT);
+		add(list, Blocks.FARMLAND_DIRT);
+
+		add(list, Blocks.DIRT_SCORCHED);
+		add(list, Blocks.DIRT_SCORCHED_RICH);
+
+		add(list, Blocks.MUD);
+		add(list, Blocks.MUD_BAKED);
+
+		add(list, Blocks.SAND);
+
+		add(list, Blocks.SANDSTONE);
+		add(list, Blocks.STAIRS_SANDSTONE);
+		add(list, Blocks.SLAB_SANDSTONE);
+
+		add(list, Blocks.BRICK_SANDSTONE);
+		add(list, Blocks.STAIRS_BRICK_SANDSTONE);
+		add(list, Blocks.SLAB_BRICK_SANDSTONE);
+
+		add(list, Blocks.GRAVEL);
+
+		add(list, Blocks.BRIMSAND);
+
+		add(list, Blocks.BRIMSTONE);
+		add(list, Blocks.BRIMTHAW);
+		add(list, Blocks.STAIRS_BRIMSTONE);
+		add(list, Blocks.SLAB_BRIMSTONE);
+
+		add(list, Blocks.BRICK_BRIMSTONE);
+		add(list, Blocks.STAIRS_BRICK_BRIMSTONE);
+		add(list, Blocks.SLAB_BRICK_BRIMSTONE);
+
+		add(list, Blocks.SULFUR);
+		add(list, Blocks.SULFUR_HARDENED);
+
+		add(list, Blocks.BLOCK_SNOW);
+		add(list, Blocks.LAYER_SNOW);
+
+		add(list, Blocks.BLOCK_ASH);
+		add(list, Blocks.LAYER_ASH);
+
+		add(list, Blocks.ICE);
+		add(list, Blocks.PERMAICE);
+
+		add(list, Blocks.BLOCK_CLAY);
+
+		add(list, Blocks.BRICK_CLAY);
+		add(list, Blocks.STAIRS_BRICK_CLAY);
+		add(list, Blocks.SLAB_BRICK_CLAY);
+
+		add(list, Blocks.OBSIDIAN);
+		add(list, Blocks.BONESHALE);
+		add(list, Blocks.BEDROCK);
+
+		add(list, Blocks.MAGMA);
+		add(list, Blocks.SOULSAND);
+		add(list, Blocks.SOULSCHIST);
+
+		add(list, Blocks.GLOWSTONE);
+
+		add(list, Blocks.THERMAL_VENT);
+
+		add(list, Blocks.EMBER);
+	}
+
+	public static void addRedstoneTypes(List<ItemStack> list) {
+		add(list, Blocks.TORCH_REDSTONE_ACTIVE);
+		add(list, Blocks.LEVER_COBBLE_STONE);
+
+		add(list, Blocks.BUTTON_STONE);
+		add(list, Blocks.BUTTON_PLANKS);
+		addPainted(list, Blocks.BUTTON_PLANKS_PAINTED, painted(Blocks.BUTTON_PLANKS_PAINTED));
+
+		add(list, Blocks.PRESSURE_PLATE_STONE);
+		add(list, Blocks.PRESSURE_PLATE_COBBLE_STONE);
+		add(list, Blocks.PRESSURE_PLATE_PLANKS_OAK);
+		addPainted(list, Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED, painted(Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED));
+
+		add(list, Blocks.PISTON_BASE);
+		add(list, Blocks.PISTON_BASE_STICKY);
+		add(list, Blocks.PISTON_BASE_STEEL);
+
+		add(list, Blocks.DISPENSER_COBBLE_STONE);
+		add(list, Blocks.MOTION_SENSOR_IDLE);
+		add(list, Blocks.ACTIVATOR);
+		add(list, Blocks.MATCHER);
+
+		add(list, Blocks.PUMPKIN_REDSTONE);
+
+		add(list, Blocks.RUBYGLASS_COLUMN);
+		add(list, Blocks.RUBYGLASS_NODE);
+		add(list, Blocks.BLOCK_RUBYGLASS);
+		add(list, Blocks.CONDUIT);
+		add(list, Blocks.RUBYGLASS_GROWTH);
+		add(list, Blocks.RUBYGLASS_CRYSTAL);
+
+		add(list, Blocks.BRAZIER_INACTIVE);
+
+		add(list, Blocks.MESH);
+		add(list, Blocks.MESH_GOLD);
+
+		add(list, Blocks.MOBSPAWNER);
+		add(list, Blocks.MOBSPAWNER_DEACTIVATED);
+
+		add(list, Blocks.NOTEBLOCK);
+		add(list, Blocks.JUKEBOX);
+
+		add(list, Blocks.RAIL);
+		add(list, Blocks.RAIL_POWERED);
+		add(list, Blocks.RAIL_DETECTOR);
+
+		add(list, Blocks.TNT);
+		add(list, Blocks.SPIKES);
+
+		add(list, Blocks.TRAPDOOR_IRON);
+		add(list, Blocks.TRAPDOOR_STEEL);
+
+		addPainted(list, Blocks.LAMP_IDLE, painted(Blocks.LAMP_IDLE));
+	}
+
+	public static void addOreTypes(List<ItemStack> list) {
+		add(list, Blocks.ORE_COAL_STONE);
+		add(list, Blocks.ORE_COAL_BASALT);
+		add(list, Blocks.ORE_COAL_LIMESTONE);
+		add(list, Blocks.ORE_COAL_GRANITE);
+		add(list, Blocks.ORE_COAL_PERMAFROST);
+
+		add(list, Blocks.ORE_IRON_STONE);
+		add(list, Blocks.ORE_IRON_BASALT);
+		add(list, Blocks.ORE_IRON_LIMESTONE);
+		add(list, Blocks.ORE_IRON_GRANITE);
+		add(list, Blocks.ORE_IRON_PERMAFROST);
+
+		add(list, Blocks.ORE_GOLD_STONE);
+		add(list, Blocks.ORE_GOLD_BASALT);
+		add(list, Blocks.ORE_GOLD_LIMESTONE);
+		add(list, Blocks.ORE_GOLD_GRANITE);
+		add(list, Blocks.ORE_GOLD_PERMAFROST);
+
+		add(list, Blocks.ORE_LAPIS_STONE);
+		add(list, Blocks.ORE_LAPIS_BASALT);
+		add(list, Blocks.ORE_LAPIS_LIMESTONE);
+		add(list, Blocks.ORE_LAPIS_GRANITE);
+		add(list, Blocks.ORE_LAPIS_PERMAFROST);
+
+		add(list, Blocks.ORE_REDSTONE_STONE);
+		add(list, Blocks.ORE_REDSTONE_BASALT);
+		add(list, Blocks.ORE_REDSTONE_LIMESTONE);
+		add(list, Blocks.ORE_REDSTONE_GRANITE);
+		add(list, Blocks.ORE_REDSTONE_PERMAFROST);
+
+		add(list, Blocks.ORE_DIAMOND_STONE);
+		add(list, Blocks.ORE_DIAMOND_BASALT);
+		add(list, Blocks.ORE_DIAMOND_LIMESTONE);
+		add(list, Blocks.ORE_DIAMOND_GRANITE);
+		add(list, Blocks.ORE_DIAMOND_PERMAFROST);
+
+		add(list, Blocks.ORE_NETHERCOAL_BASALT);
+		add(list, Blocks.ORE_NETHERCOAL_NETHERRACK);
+		add(list, Blocks.ORE_NETHERCOAL_GLOOMSTONE);
+	}
+
+	public static void addStorageTypes(List<ItemStack> list) {
+		add(list, Blocks.BLOCK_IRON);
+		add(list, Blocks.BLOCK_STEEL);
+		add(list, Blocks.BLOCK_GOLD);
+		add(list, Blocks.BLOCK_LAPIS);
+		add(list, Blocks.BLOCK_REDSTONE);
+		add(list, Blocks.BLOCK_DIAMOND);
+		add(list, Blocks.BLOCK_QUARTZ);
+
+		add(list, Blocks.BLOCK_COAL);
+		add(list, Blocks.BLOCK_CHARCOAL);
+		add(list, Blocks.BLOCK_NETHER_COAL);
+		add(list, Blocks.BLOCK_OLIVINE);
+
+		add(list, Blocks.BRICK_IRON);
+		add(list, Blocks.STAIRS_BRICK_IRON);
+		add(list, Blocks.SLAB_BRICK_IRON);
+
+		add(list, Blocks.BRICK_STEEL);
+		add(list, Blocks.STAIRS_BRICK_STEEL);
+		add(list, Blocks.SLAB_BRICK_STEEL);
+
+		add(list, Blocks.BRICK_GOLD);
+		add(list, Blocks.STAIRS_BRICK_GOLD);
+		add(list, Blocks.SLAB_BRICK_GOLD);
+
+		add(list, Blocks.BRICK_LAPIS);
+		add(list, Blocks.STAIRS_BRICK_LAPIS);
+		add(list, Blocks.SLAB_BRICK_LAPIS);
+
+		add(list, Blocks.BRICK_DIAMOND);
+		add(list, Blocks.STAIRS_BRICK_DIAMOND);
+		add(list, Blocks.SLAB_BRICK_DIAMOND);
+
+		add(list, Blocks.BRICK_QUARTZ);
+		add(list, Blocks.STAIRS_BRICK_QUARTZ);
+		add(list, Blocks.SLAB_BRICK_QUARTZ);
+
+		add(list, Blocks.BRICK_OLIVINE);
+		add(list, Blocks.STAIRS_BRICK_OLIVINE);
+		add(list, Blocks.SLAB_BRICK_OLIVINE);
+
+		add(list, Blocks.BRICK_RUBYGLASS);
+		add(list, Blocks.STAIRS_BRICK_RUBYGLASS);
+		add(list, Blocks.SLAB_BRICK_RUBYGLASS);
+
+	}
+
+	private static void addPainted(List<ItemStack> list, Block<?> block, IPainted painted) {
+		for (DyeColor color : RAINBOW_ORDER) {
+			list.add(new ItemStack(block, 1, painted.toMetadata(color)));
+		}
+	}
+
+	private static void add(List<ItemStack> list, Block<?>... blocks) {
+		for (Block<?> block : blocks) {
+			list.add(new ItemStack(block));
+		}
+	}
+
+	private static IPainted painted(Block<?> block) {
+		return (IPainted) block.getLogic();
+	}
+
+}
+
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeItems.java b/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeItems.java
new file mode 100644
index 000000000..959f19131
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeItems.java
@@ -0,0 +1,331 @@
+package net.minecraft.core.player.inventory;
+
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemBucket;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.DyeColor;
+
+import java.util.List;
+
+public final class CreativeItems {
+
+	private static final DyeColor[] RAINBOW_ORDER = {
+		DyeColor.RED,
+		DyeColor.ORANGE,
+		DyeColor.YELLOW,
+		DyeColor.LIME,
+		DyeColor.GREEN,
+		DyeColor.CYAN,
+		DyeColor.LIGHT_BLUE,
+		DyeColor.BLUE,
+		DyeColor.PURPLE,
+		DyeColor.MAGENTA,
+		DyeColor.PINK,
+		DyeColor.BROWN,
+		DyeColor.WHITE,
+		DyeColor.SILVER,
+		DyeColor.GRAY,
+		DyeColor.BLACK
+	};
+
+	private static void addBucketVariants(List<ItemStack> out, Item item) {
+		if (item instanceof ItemBucket itemBucket) {
+			out.add(new ItemStack(item));
+			for (NamespaceID stateId : ItemBucket.getRegisteredStateIds()) {
+				if (!ItemBucket.STATE_EMPTY.equals(stateId)) {
+					ItemStack itemStack = new ItemStack(item, 1);
+					ItemBucket.setState(itemStack, stateId);
+					ItemBucket.setCharges(itemStack, itemBucket.maxCharges);
+					out.add(itemStack);
+				}
+			}
+		}
+	}
+
+	public static void populate(List<ItemStack> out) {
+
+		//TOOLS
+		out.add(new ItemStack(Items.TOOL_SHOVEL_WOOD));
+		out.add(new ItemStack(Items.TOOL_PICKAXE_WOOD));
+		out.add(new ItemStack(Items.TOOL_AXE_WOOD));
+		out.add(new ItemStack(Items.TOOL_HOE_WOOD));
+		out.add(new ItemStack(Items.TOOL_SWORD_WOOD));
+
+		out.add(new ItemStack(Items.TOOL_SHOVEL_STONE));
+		out.add(new ItemStack(Items.TOOL_PICKAXE_STONE));
+		out.add(new ItemStack(Items.TOOL_AXE_STONE));
+		out.add(new ItemStack(Items.TOOL_HOE_STONE));
+		out.add(new ItemStack(Items.TOOL_SWORD_STONE));
+
+		out.add(new ItemStack(Items.TOOL_SHOVEL_IRON));
+		out.add(new ItemStack(Items.TOOL_PICKAXE_IRON));
+		out.add(new ItemStack(Items.TOOL_AXE_IRON));
+		out.add(new ItemStack(Items.TOOL_HOE_IRON));
+		out.add(new ItemStack(Items.TOOL_SWORD_IRON));
+
+		out.add(new ItemStack(Items.TOOL_SHOVEL_GOLD));
+		out.add(new ItemStack(Items.TOOL_PICKAXE_GOLD));
+		out.add(new ItemStack(Items.TOOL_AXE_GOLD));
+		out.add(new ItemStack(Items.TOOL_HOE_GOLD));
+		out.add(new ItemStack(Items.TOOL_SWORD_GOLD));
+
+		out.add(new ItemStack(Items.TOOL_SHOVEL_DIAMOND));
+		out.add(new ItemStack(Items.TOOL_PICKAXE_DIAMOND));
+		out.add(new ItemStack(Items.TOOL_AXE_DIAMOND));
+		out.add(new ItemStack(Items.TOOL_HOE_DIAMOND));
+		out.add(new ItemStack(Items.TOOL_SWORD_DIAMOND));
+
+		out.add(new ItemStack(Items.TOOL_SHOVEL_STEEL));
+		out.add(new ItemStack(Items.TOOL_PICKAXE_STEEL));
+		out.add(new ItemStack(Items.TOOL_AXE_STEEL));
+		out.add(new ItemStack(Items.TOOL_HOE_STEEL));
+		out.add(new ItemStack(Items.TOOL_SWORD_STEEL));
+
+
+		//MISC TOOLS
+		out.add(new ItemStack(Items.TOOL_FIRESTRIKER_IRON));
+		out.add(new ItemStack(Items.TOOL_FIRESTRIKER_STEEL));
+
+		out.add(new ItemStack(Items.TOOL_SHEARS));
+		out.add(new ItemStack(Items.TOOL_SHEARS_STEEL));
+
+		addBucketVariants(out, Items.BUCKET_IRON);
+		addBucketVariants(out, Items.BUCKET_STEEL);
+
+		out.add(new ItemStack(Items.PAINTBRUSH));
+
+		out.add(new ItemStack(Items.TOOL_FISHINGROD));
+
+		out.add(new ItemStack(Items.TOOL_BOW));
+		out.add(new ItemStack(Items.AMMO_ARROW));
+		out.add(new ItemStack(Items.AMMO_ARROW_GOLD));
+		out.add(new ItemStack(Items.AMMO_ARROW_PURPLE));
+		out.add(new ItemStack(Items.AMMO_ARROW_FLAMING));
+
+		out.add(new ItemStack(Items.HANDCANNON_UNLOADED));
+		out.add(new ItemStack(Items.AMMO_CHARGE_EXPLOSIVE));
+
+		out.add(new ItemStack(Items.AMMO_FIREBALL));
+
+		out.add(new ItemStack(Items.TOOL_COMPASS));
+		out.add(new ItemStack(Items.TOOL_CLOCK));
+		out.add(new ItemStack(Items.TOOL_CALENDAR));
+		out.add(new ItemStack(Items.MAP));
+
+		out.add(new ItemStack(Items.ROPE));
+
+		out.add(new ItemStack(Items.LABEL));
+
+		out.add(new ItemStack(Items.WAND_MONSTER_SPAWNER));
+		out.add(new ItemStack(Items.WAND_NBT));
+
+
+		//ARMOR
+		out.add(new ItemStack(Items.ARMOR_HELMET_LEATHER));
+		out.add(new ItemStack(Items.ARMOR_CHESTPLATE_LEATHER));
+		out.add(new ItemStack(Items.ARMOR_LEGGINGS_LEATHER));
+		out.add(new ItemStack(Items.ARMOR_BOOTS_LEATHER));
+
+		out.add(new ItemStack(Items.ARMOR_HELMET_CHAINMAIL));
+		out.add(new ItemStack(Items.ARMOR_CHESTPLATE_CHAINMAIL));
+		out.add(new ItemStack(Items.ARMOR_LEGGINGS_CHAINMAIL));
+		out.add(new ItemStack(Items.ARMOR_BOOTS_CHAINMAIL));
+
+		out.add(new ItemStack(Items.ARMOR_HELMET_IRON));
+		out.add(new ItemStack(Items.ARMOR_CHESTPLATE_IRON));
+		out.add(new ItemStack(Items.ARMOR_LEGGINGS_IRON));
+		out.add(new ItemStack(Items.ARMOR_BOOTS_IRON));
+
+		out.add(new ItemStack(Items.ARMOR_HELMET_GOLD));
+		out.add(new ItemStack(Items.ARMOR_CHESTPLATE_GOLD));
+		out.add(new ItemStack(Items.ARMOR_LEGGINGS_GOLD));
+		out.add(new ItemStack(Items.ARMOR_BOOTS_GOLD));
+
+		out.add(new ItemStack(Items.ARMOR_HELMET_DIAMOND));
+		out.add(new ItemStack(Items.ARMOR_CHESTPLATE_DIAMOND));
+		out.add(new ItemStack(Items.ARMOR_LEGGINGS_DIAMOND));
+		out.add(new ItemStack(Items.ARMOR_BOOTS_DIAMOND));
+
+		out.add(new ItemStack(Items.ARMOR_HELMET_STEEL));
+		out.add(new ItemStack(Items.ARMOR_CHESTPLATE_STEEL));
+		out.add(new ItemStack(Items.ARMOR_LEGGINGS_STEEL));
+		out.add(new ItemStack(Items.ARMOR_BOOTS_STEEL));
+
+		out.add(new ItemStack(Items.ARMOR_QUIVER));
+		out.add(new ItemStack(Items.ARMOR_QUIVER_GOLD));
+		out.add(new ItemStack(Items.ARMOR_BOOTS_ICESKATES));
+
+		out.add(new ItemStack(Items.ARMOR_WOLF_LEATHER));
+		out.add(new ItemStack(Items.ARMOR_WOLF_CHAINMAIL));
+		out.add(new ItemStack(Items.ARMOR_WOLF_IRON));
+		out.add(new ItemStack(Items.ARMOR_WOLF_GOLD));
+		out.add(new ItemStack(Items.ARMOR_WOLF_DIAMOND));
+		out.add(new ItemStack(Items.ARMOR_WOLF_STEEL));
+
+
+		//FOOD
+		out.add(new ItemStack(Items.FOOD_APPLE));
+		out.add(new ItemStack(Items.FOOD_APPLE_GOLD));
+
+		out.add(new ItemStack(Items.FOOD_CHERRY));
+
+		out.add(new ItemStack(Items.FOOD_PORKCHOP_RAW));
+		out.add(new ItemStack(Items.FOOD_PORKCHOP_COOKED));
+
+		out.add(new ItemStack(Items.FOOD_VENISON_RAW));
+		out.add(new ItemStack(Items.FOOD_VENISON_COOKED));
+
+		out.add(new ItemStack(Items.FOOD_FISH_RAW));
+		out.add(new ItemStack(Items.FOOD_FISH_COOKED));
+
+		out.add(new ItemStack(Items.DUST_SUGAR));
+		out.add(new ItemStack(Items.EGG_CHICKEN));
+
+		out.add(new ItemStack(Items.SEEDS_WHEAT));
+		out.add(new ItemStack(Items.SEEDS_PUMPKIN));
+
+		out.add(new ItemStack(Items.WHEAT));
+		out.add(new ItemStack(Items.DOUGH));
+		out.add(new ItemStack(Items.FOOD_BREAD));
+
+		out.add(new ItemStack(Items.FOOD_COOKIE));
+		out.add(new ItemStack(Items.FOOD_CAKE));
+		out.add(new ItemStack(Items.FOOD_PUMPKIN_PIE));
+
+		out.add(new ItemStack(Items.BOWL));
+		out.add(new ItemStack(Items.FOOD_STEW_MUSHROOM));
+
+
+		//ORE
+		out.add(new ItemStack(Items.AMMO_PEBBLE));
+
+		out.add(new ItemStack(Items.COAL));
+		out.add(new ItemStack(Items.COAL, 1, 1));
+		out.add(new ItemStack(Items.NETHERCOAL));
+		out.add(new ItemStack(Items.OLIVINE));
+
+		out.add(new ItemStack(Items.ORE_RAW_IRON));
+		out.add(new ItemStack(Items.INGOT_IRON));
+
+		out.add(new ItemStack(Items.DIAMOND));
+
+		out.add(new ItemStack(Items.INGOT_STEEL_CRUDE));
+		out.add(new ItemStack(Items.INGOT_STEEL));
+
+		out.add(new ItemStack(Items.ORE_RAW_GOLD));
+		out.add(new ItemStack(Items.INGOT_GOLD));
+
+		out.add(new ItemStack(Items.DUST_REDSTONE));
+
+		out.add(new ItemStack(Items.REPEATER));
+
+		out.add(new ItemStack(Items.TIMER));
+
+		out.add(new ItemStack(Items.QUARTZ));
+
+		out.add(new ItemStack(Items.FLINT));
+		out.add(new ItemStack(Items.CLAY));
+		out.add(new ItemStack(Items.BRICK_CLAY));
+
+		out.add(new ItemStack(Items.DUST_GLOWSTONE));
+
+		out.add(new ItemStack(Items.RUBYGLASS));
+
+		out.add(new ItemStack(Items.SULFUR));
+
+
+		//Materials
+		out.add(new ItemStack(Items.STICK));
+		out.add(new ItemStack(Items.AMMO_SNOWBALL));
+		out.add(new ItemStack(Items.SUGARCANE));
+		out.add(new ItemStack(Items.PAPER));
+		out.add(new ItemStack(Items.BOOK));
+		for (DyeColor color : RAINBOW_ORDER) {
+			int meta = color.itemMeta;
+			out.add(new ItemStack(Items.DYE, 1, meta));
+		}
+
+		//Mob Drops
+		out.add(new ItemStack(Items.CLOTH));
+		out.add(new ItemStack(Items.STRING));
+		out.add(new ItemStack(Items.FEATHER_CHICKEN));
+		out.add(new ItemStack(Items.GUNPOWDER));
+		out.add(new ItemStack(Items.BONE));
+		out.add(new ItemStack(Items.CHAINLINK));
+		out.add(new ItemStack(Items.SLIMEBALL));
+		out.add(new ItemStack(Items.LEATHER));
+
+		//Placeables
+		out.add(new ItemStack(Items.PAINTING));
+
+		out.add(new ItemStack(Items.DOOR_OAK));
+		for (DyeColor color : RAINBOW_ORDER) {
+			int meta = color.itemMeta;
+			out.add(new ItemStack(Items.DOOR_OAK_PAINTED, 1, meta));
+		}
+
+		out.add(new ItemStack(Items.DOOR_GLASS));
+		out.add(new ItemStack(Items.DOOR_IRON));
+		out.add(new ItemStack(Items.DOOR_STEEL));
+
+		out.add(new ItemStack(Items.SIGN));
+		for (DyeColor color : RAINBOW_ORDER) {
+			int meta = color.itemMeta;
+			out.add(new ItemStack(Items.SIGN_PAINTED, 1, meta));
+		}
+
+		out.add(new ItemStack(Items.FLAG));
+		out.add(new ItemStack(Items.BED));
+		out.add(new ItemStack(Items.SEAT));
+
+		out.add(new ItemStack(Items.BASKET));
+
+		out.add(new ItemStack(Items.JAR));
+
+		out.add(new ItemStack(Items.LANTERN_FIREFLY_GREEN));
+		out.add(new ItemStack(Items.LANTERN_FIREFLY_BLUE));
+		out.add(new ItemStack(Items.LANTERN_FIREFLY_ORANGE));
+		out.add(new ItemStack(Items.LANTERN_FIREFLY_RED));
+
+		out.add(new ItemStack(Items.JAR_BUTTERFLY_BLUE));
+		out.add(new ItemStack(Items.JAR_BUTTERFLY_ORANGE));
+		out.add(new ItemStack(Items.JAR_BUTTERFLY_PINK));
+		out.add(new ItemStack(Items.JAR_BUTTERFLY_SILVER));
+
+		out.add(new ItemStack(Items.STATUE_STONE));
+		out.add(new ItemStack(Items.STATUE_BASALT));
+		out.add(new ItemStack(Items.STATUE_LIMESTONE));
+		out.add(new ItemStack(Items.STATUE_GRANITE));
+		out.add(new ItemStack(Items.STATUE_PERMAFROST));
+		out.add(new ItemStack(Items.STATUE_MARBLE));
+		out.add(new ItemStack(Items.STATUE_SLATE));
+		out.add(new ItemStack(Items.STATUE_NETHERRACK));
+		out.add(new ItemStack(Items.STATUE_GLOOMSTONE));
+		out.add(new ItemStack(Items.STATUE_PIGMAN));
+
+		out.add(new ItemStack(Items.SADDLE));
+
+		out.add(new ItemStack(Items.BOAT));
+
+		out.add(new ItemStack(Items.MINECART));
+		out.add(new ItemStack(Items.MINECART_CHEST));
+		out.add(new ItemStack(Items.MINECART_FURNACE));
+
+		// Records
+		out.add(new ItemStack(Items.RECORD_13));
+		out.add(new ItemStack(Items.RECORD_CAT));
+
+		out.add(new ItemStack(Items.RECORD_BLOCKS));
+		out.add(new ItemStack(Items.RECORD_CHIRP));
+		out.add(new ItemStack(Items.RECORD_FAR));
+		out.add(new ItemStack(Items.RECORD_MALL));
+		out.add(new ItemStack(Items.RECORD_MELLOHI));
+		out.add(new ItemStack(Items.RECORD_STAL));
+		out.add(new ItemStack(Items.RECORD_STRAD));
+		out.add(new ItemStack(Items.RECORD_WARD));
+		out.add(new ItemStack(Items.RECORD_WAIT));
+		out.add(new ItemStack(Items.RECORD_DOG));
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
index a721eea58..75b22c5cf 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
@@ -7,6 +7,8 @@ import net.minecraft.core.item.*;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.player.inventory.CreativeBlocks;
+import net.minecraft.core.player.inventory.CreativeItems;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.slot.SlotCreative;
 import net.minecraft.core.util.collection.NamespaceID;
@@ -124,7 +126,13 @@ public class MenuInventoryCreative extends MenuInventory
 
 	static
 	{
-		for (Block<?> block : Blocks.blocksList) {
+		CreativeBlocks.populate(creativeItems);
+		CreativeItems.populate(creativeItems);
+	}
+
+	// PREVIOUS IMPLEMENTATION:
+
+		/*for (Block<?> block : Blocks.blocksList) {
 			if (block == null || block.hasTag(BlockTags.NOT_IN_CREATIVE_MENU)) continue;
 
 			if (Block.hasLogicClass(block, IPainted.class)) {
@@ -168,5 +176,5 @@ public class MenuInventoryCreative extends MenuInventory
 				creativeItems.add(new ItemStack(item));
 			}
 		}
-	}
+	}*/
 }
